/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007-2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: tool_stddef.h 164 2016-03-07 11:33:50Z coas-nagasima $
 */

/*
 *  t_stddef.h̊JˑilTX RXc[`FCpj
 *
 *  ̃CN[ht@ĆCt_stddef.h ̐擪ŃCN[hD
 *  ̃t@C͒ڃCN[h邱Ƃ͂ȂD̃CN[h
 *  t@Cɐ旧ď邽߁C̃CN[ht@CɈˑ
 *  Ă͂ȂȂD
 */

#if !defined( TOPPERS_TOOL_STDDEF_H )
#define TOPPERS_TOOL_STDDEF_H

/*
 *  RpC̊g@\̂߂̃}N`
 */
/*
 *  inline ʎq͊O`𐶐Ȃ.
 */
#define	Inline		static inline

/*
 *  CCAZu͖{RpCł
 *  #pragma inline_asm݂̂̃T|[gƂȂ邽,
 *  asm/Asm`͍sȂ.
 */

/*
 *  NoReturn / alignof͖{RpCł̓T|[gȂ.
 *  offsetofstddef.h̒`𗘗p.
 */
#define	NoReturn


/*
 *  J̕WCN[ht@C̗p
 *
 *  NULL̒`stddef.hCINT_MAXCINT_MINCUINT_MAXCLONG_MAXC
 *  LONG_MINCULONG_MAXCCHAR_BIT̒`limits.h荞ށD
 *
 *  C++/EC++ł́CWdl͂̃CN[ht@Cpӂ
 *  Ƃ͌Ȃ̂ŒӂKvłiقƂǂ̊Jŗpӂ
 *  ĂjD
 */
#ifndef TOPPERS_MACRO_ONLY
#include <stddef.h>
#include <limits.h>
#endif /* TOPPERS_MACRO_ONLY */


/*
 *  RpCˑ̃f[^^̒`
 *
 *  stdint.hCN[h
 */
#ifndef TOPPERS_MACRO_ONLY
#include <stdint.h>
#endif /* TOPPERS_MACRO_ONLY */


/*
 *  _^Ɋւ`
 *
 *  L̒`dbl_size = 8IvVw肵ꍇ̂ݗLƂ邱.
 */
#ifndef TOPPERS_MACRO_ONLY
typedef float		float32_t;			/* IEEE754̒Px_ */
typedef double		double64_t;			/* IEEE754̔{x_ */
#endif /* TOPPERS_MACRO_ONLY */

#define FLOAT32_MIN		( 1.4012984643248171e-45F )
#define FLOAT32_MAX		( 3.4028234663852886e+38F )
#define DOUBLE64_MIN	( 4.9406564584124654e-324 )
#define DOUBLE64_MAX	( 1.7976931348623157e+308 )


/*
 *  󃉃x̒`
 *
 *  {RpCł͑傫[̔z̓RpCG[ɂȂ邽,
 *  TCY1ɂĒ`.
 */
#define TOPPERS_EMPTY_LABEL( type, symbol )		type symbol[ 1 ]


#endif /* TOPPERS_TOOL_STDDEF_H */

