/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: prc_support.cpp 164 2016-03-07 11:33:50Z coas-nagasima $
 */

#include "StdAfx.h"
#include "prc_insn.h"
#include "WinKernel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// hsqnmJ[l
extern CKernel *g_Kernel;

uint32_t psw = PSW_I_MASK;

uint32_t current_psw(void)
{
	return psw;
}

void set_psw(uint32_t psw)
{
	uint32_t temp = ::psw ^ psw;

	::psw = psw;

	if((temp & PSW_I_MASK) != 0) {
		if((psw & PSW_I_MASK) != 0)
			g_Kernel->LockCPU();
		else
			g_Kernel->UnlockCPU();
	}
}

/*
 *  NMIׂĂ݂̊̋֎~
 */
void disint(void)
{
	g_Kernel->LockCPU();

	psw |= PSW_I_MASK;
}

/*
 *  NMIׂĂ݂̊̋
 */
void enaint(void)
{
	psw &= ~PSW_I_MASK;

	g_Kernel->UnlockCPU();
}

/*
 *  ݃nh̐ݒ
 */
void x_define_inh(uint_t inhno, FP int_entry)
{
	g_Kernel->DefineInterruptHandler(inhno, int_entry);
}

void i_begin_int(INTNO intno)
{
	g_Kernel->BeginInt();
}

void i_end_int(INTNO intno)
{
	g_Kernel->EndInt();
}

bool starting = true;

bool_t t_sense_lock()
{
	return g_Kernel->CurrentIsLocked();
}

bool_t i_sense_lock()
{
	return g_Kernel->IsLocked();
}

bool_t x_sense_lock()
{
	if(g_Kernel->InTaskContext())
		return g_Kernel->CurrentIsLocked();
	else
		return g_Kernel->IsLocked();
}

/*
 *  ReLXg̎Q
 */
bool_t sense_context(void)
{
	return !g_Kernel->InTaskContext() && !starting;
}

/*
 *  CPUO̔̃ReLXg̎Q
 */
bool_t exc_sense_context( void *p_excinf )
{
	return !g_Kernel->InTaskContext() && !starting;
}

/*
 *  J[lN^XNfBXpb`
 */
void _start_dispatch(void)
{
	starting = false;
}

/*
 *  ^XNfBXpb`
 */
void dispatch(void)
{
	g_Kernel->Dispatch();
}

/*
 *  ݂̃ReLXĝĂăfBXpb`
 */
void _exit_and_dispatch(void)
{
	g_Kernel->ExitAndDispatch();
}

/*
 *  J[l̏Ǐďo
 * 
 *  X^bN^XNReLXgpɐ؂ւD
 * 
 */
void call_exit_kernel(void)
{
	g_Kernel->Terminate();
}

/*
 *  ^XNN
 * 
 */ 
void start_r(void)
{
#if TIPM_LOCK != -15
	lock_flag = false;
#endif	/* TIPM_LOCK != -15	*/
}

extern "C" void Throw()
{
	throw std::exception();
}

extern "C" void trigger_cpu_exception( void )
{
	throw std::exception();
}
